package com.sd.framework.util.sql.mapper;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.sd.framework.util.sql.MybatisConstant;
import com.sd.framework.util.sql.Where;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Select;

import java.util.List;
import java.util.Map;

public interface JoinMapper {

    @Select(MybatisConstant.SQL_SCRIPT)
    List<Map<String, Object>> list(@Param(MybatisConstant.SQL) String sql,
                                   @Param(MybatisConstant.WRAPPER) Where<?> wrapper);

    @Select(MybatisConstant.SQL_SCRIPT)
    Page<Map<String, Object>> page(@Param(MybatisConstant.SQL) String sql,
                                   @Param(MybatisConstant.PAGE) Page<?> page,
                                   @Param(MybatisConstant.WRAPPER) Where<?> wrapper);

    @Select(MybatisConstant.SQL_SCRIPT)
    Map<String, Object> one(@Param(MybatisConstant.SQL) String sql,
                            @Param(MybatisConstant.WRAPPER) Where<?> wrapper);

}
